/** fMSX: portable MSX emulator ******************************/
/**                                                         **/
/**               Keyboard.h                                **/
/**                                                         **/
/** This file contains the prototypes for the functions     **/ 
/** handling the KeyBoard                                   **/
/** To be used together with the improved X11-drivers       **/ 
/** written by Arnold Metselaar.                            **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994-2001                 **/
/**               Arnold Metselaar 2001                     **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify us, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/
#include <X11/Xlib.h>

/** can be used to receive command line options that are specific to
    the keyboard driver. must return a nonzero value if the option is
    recognised */
int KeyboardOption(int argc, char *argv[], int *N);

/** can be used to receive run-time commands that are specific to the
    keyboard driver. must return a nonzero value if the command is
    recognised */
int KeyboardCommand(int argc, char *argv[], int *N);

/** called just after the window is mapped */
int InitKeyboard(Display *Dsp, Window Wnd);

/** called just after deallocating colors, before other deallocations */
void TrashKeyboard(Display *Dsp, Window Wnd);

/** called for each XKeyEvent received, should return nozero if no
    further keyevents are requested for this interrupt (key buffering) */
int OnKeyEvent(XKeyEvent *E);

/** called when fMSX gains focus */
void OnFocusIn(XFocusChangeEvent * E);

/** called when fMSX loses focus */
void OnFocusOut(XFocusChangeEvent * E);
